require_dependency 'hasura_handler/application_controller'

module HasuraHandler
  class EventsController < ApplicationController
    before_action :check_header

    def index
      processor = HasuraHandler::EventProcessor.new(raw_params)

      unless processor.event.valid?
        error_response(processor.event.errors)
        return
      end

      if HasuraHandler.async_events
        processor.process_later
        render json: { queued: true }, status: 202
        return
      end

      processor.process
      if processor.success?
        render json: { success: true }
      else
        error_response(processor.errors)
      end
    end

    private

    def error_response(errors)
      render json: { success: false, errors: errors }, status: 400
    end
  end
end
